/********************************************************
 * serial -- Determine how long it will take to 	*
 *		transmit a file at 9600 baud over	*
 *		a serial line.				*
 *							*
 * Programming Problem: 7-3.				*
 *							*
 * Usage:						*
 *	Run the program.				*
 *	Type in the size of the file in bytes.		*
 *	Get the results.				*
 ********************************************************/
#include <iostream.h>

const int speed = 9600;	// Speed of the transmission line (bits/second)

/*
 * Units of times.  Names of these are in "time_names"
 */
const double times[] = {
    1.0 * 60.0 * 60.0 * 24.0 * 7.0,	/* Weeks */
    1.0 * 60.0 * 60.0 * 24.0,		/* Days */
    1.0 * 60.0 * 60.0,			/* Hours */
    1.0 * 60.0,				/* Minutes */
    1.0					/* Seconds */
};	

/*
 * Names of the various units that are in times
 */
const char time_names[][20] = {
    "Weeks",
    "Days",
    "Hours",
    "Minutes",
    "Seconds"
};

long unsigned int file_size;	// Size of the file
float time;			// Time to transmit the file
int unit_index;			// Index into the unit array

main()
{
    cout << "File size in bytes: ";
    cin >> file_size;

    unit_index = 0;
    while (1) {
	// 10 bits/second = 1 character/second
	time = float(file_size) / times[unit_index] / float(speed / 10.0);

	if ((time >= 1.0) || (times[unit_index] == 1.0)) {
	   cout << "Time to transmit " << file_size << " bytes\n";
	   cout << time << ' ' << time_names[unit_index] << '\n';
	   break;
	}
	++unit_index;
    }
    return (0);
}

