/********************************************************
 * pack -- pack all the bits into the left of a number	*
 *							*
 * Programming Problem: 11-6				*
 *							*
 * Usage:						*
 *	Run the program					*
 *	Type in a number				*
 *	Get the binary of the number out		*
 *	Get the packed number out			*
 *	Get the binary of the packed number out		*
 ********************************************************/
#include <iostream.h>

const int BIT_MAX = 32;	// Biggest bit in a "long int"
			// 99% of the systems use 32 bit long integers
			// This won't work on the other 1%

/********************************************************
 * write_binary -- write a number out as binary		*
 ********************************************************/
void write_binary(
    const long int number	// Number to write
)
{
    unsigned long int i;	// General purpose index

    cout << number << " as binary ";
    for (i = (1 << (BIT_MAX-1)); i > 0; i >>= 1) {
	if ((number & i) != 0) 
	    cout << '1';
	 else
	    cout << '0';
    }
    cout << '\n';
}
main()
{
    unsigned long int test_index;	// Index of bits to test
    unsigned long int set_index;	// Index of bits to set
    long int number; 			// Number from the user
    long int result = 0;		// Result of packing

    cout << "Enter number: ";
    cin >> number;

    set_index = (1 << (BIT_MAX-1));	// Index for output
    for (test_index = (1 << (BIT_MAX-1)); test_index > 0; test_index >>= 1) {
	// If one bit is set, set on in the result
        if ((number & test_index) != 0) {
	    result |= set_index;
	    set_index >>= 1;
	}
    }
    cout << "The input was\n";
    write_binary(number);

    cout << '\n';

    cout << "The result is\n";
    write_binary(result);
    return (0);
}




