/******************************************************** 
 * split -- split a 32 bit integer into eight 4 bit	*
 *		nibbles.				*
 *							*
 * Programming Problem 11-5				*
 *							*
 * Usage:						*
 *	Run the program.				*
 *	Type in a number.				*
 *	Get the nibbles back.				*
 *							*
 * Some code borrowed from count.cc in this chapter.	*
 ********************************************************/
#include <iostream.h>

const int BIT_MAX = 32;	// Biggest bit in a "long int"
			// 99% of the systems use 32 bit long integers
			// This won't work on the other 1%

main()
{
    unsigned long int i;	// General purpose index
    long int number; 		// Number from the user
    unsigned int nibble[8];	// The nibbles produced

    cout << "Enter number: ";
    cin >> number;

    int space_count = 0;	// Counter for spaces
    cout << number << " as binary ";
    for (i = (1 << (BIT_MAX-1)); i > 0; i >>= 1) {
	if ((number & i) != 0) {
	    cout << '1';
	} else
	    cout << '0';
	++space_count;
	if ((space_count % 4) == 0)
	    cout << ' ';
    }
    cout << '\n';

    for (i = 0; i < 8; i++) {
       // 0xF -- is 4 bits
       // We need to shift 4 bits per nibble
       nibble[i] = (0xF << (i*4)) & number;

       // We've got the nibble, but we need to put in the
       // right side of the variable
       nibble[i] >>= (i*4);
       // Make sure we don't run into sign problems
       nibble[i] &= 0xF;
    }
    for (i = 0; i < 8; i++)
	cout << nibble[i] << '\n';

    return (0);
}

