/********************************************************
 * queue -- a simple queue class and test routine	*
 *							*
 * Programming Problem: 13-3				*
 ********************************************************/
#include <iostream.h>
/********************************************************
 * Queue class.						*
 *	A queue or FIFO is a first in, first out data	*
 *	storage.					*
 * 							*
 *	Warning: We do not check for overfilling the 	*
 *	queue or emptying too much data.		*
 *							*
 * Member functions:					*
 *	put  -- puts an item in the queue		*
 *	get  -- gets an items from the queue		*
 ********************************************************/
const int QUEUE_SIZE = 100;	// Max number of elements in queue

class queue {
    private:
	unsigned short int get_index;	// Index for the next get
	unsigned short int put_index;	// Index for the next put
	int data[QUEUE_SIZE];		// Data in the queue

	// Increments (and wraps) a queue index
	void inc_index(
	    unsigned short int &index		// Index to increment
	) {
	    ++index;		// Move up
	    index %= QUEUE_SIZE;// Wrap if needed
	}
    public:
	queue(void) {
	   put_index = 0;
	   get_index = QUEUE_SIZE-1;
	}
	// Destructor defaults
    private:
	queue(const queue &);	// No copy constructor

	// No assignment operator
	queue operator= (const queue &);
    public:
	// Adds an item to the queue
	void put(
	    int item		// Item to put on the queue
	) {
	    data[put_index] = item;
	    inc_index(put_index);
	}

	// Returns the top item in the queue
	int get(void) {
	    inc_index(get_index);
	    return (data[get_index]);
	}
};

main()
{
    queue test_queue;	// Queue to test

    test_queue.put(1);
    test_queue.put(2);
    test_queue.put(3);
    test_queue.put(4);

    cout << "Get returns " << test_queue.get() << '\n';
    cout << "Get returns " << test_queue.get() << '\n';
    cout << "Get returns " << test_queue.get() << '\n';
    cout << "Get returns " << test_queue.get() << '\n';
    return (0);
}
