/********************************************************
 * set -- define an test a small set class		*
 *							*
 * Programming Problem: 13-4.				*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * small_set class -- allow setting,testing and clearing*
 *	of items in a set.  Elements must number 	*
 *	between 0-31.					*
 *							*
 * Member functions:					*
 *	set -- set an element 				*
 *	clear -- remove an element from the set		*
 *	test -- test to see if an element is in a set	*
 *	print -- print the set to cout			*
 *							*
 * Note: We probably should define operators to work	*
 * on this class, but we haven't studied operator 	*
 * overloading yet.					*
 *							*
 * Warning: We do no check the input.			*
 ********************************************************/
class small_set {
    private:
	long int value;	// Current value of the set

    public:
	small_set(void) {
	    value = 0;
	}
	// Destructor defaults
	// Copy Constructor defaults
	// Assignment operator defaults

	// Set an element in the set
	void set(
	    const int element	// Element to set
	) {
	    value |= (1 << element);
	}

	// Clear an element from the set
	void clear(
	    const int element	// Element to clear
	) {
	    value &= ~(1 << element);
	}

	// Test -- return TRUE if an element is in the set
	int test(
	    const int element	// Element to test
	) {
	    return ((value & (1 << element)) != 0);
	}
	
	// Print -- print the set
	void print(void);
};
/********************************************************
 * small_set::print -- print a set to cout		*
 ********************************************************/
void small_set::print(void)
{
    int i;	// Index into the set

    for (i = 0; i < 31; ++i) {
	if (test(i))
	   cout << i << ' ';
    }
}

main()
{
    small_set test_set;		// Set to test


    test_set.set(1);		// Set a few values
    test_set.set(3);		// Set a few values
    test_set.set(5);		// Set a few values
    test_set.set(7);		// Set a few values
    test_set.set(9);		// Set a few values

    cout << "Set= ";
    test_set.print();
    cout << '\n';

    test_set.clear(9);

    cout << "Set= ";
    test_set.print();
    cout << '\n';

    return (0);
}
