/********************************************************
 * memcpy -- memory copy clone test routine		*
 *							*
 * Programming Problem: 17-5				*
 ********************************************************/
#include <iostream.h>
#include <sys/time.h>

static char big_array[10*1024];	// One big array
static char big_array2[10*1024];// Another big array
/********************************************************
 * my_memcpy -- my version of memcpy			*
 ********************************************************/
void my_memcpy(
    register char *to_ptr,		// To pointer
    register char *from_ptr,		// From pointer
    unsigned int size			// Size of the copy
) {
    // Place we're going to wind up at
    register char *end_ptr = from_ptr + size;

    while (from_ptr < end_ptr) {
	*to_ptr = *from_ptr;
	to_ptr++;
	from_ptr++;
    }
}

// Types of memcpy
enum COPY_TYPE { COPY_NULL, COPY_ME, COPY_SYS};
/********************************************************
 * time_copy -- Time a memory copy			*
 ********************************************************/
void time_copy(
    const COPY_TYPE copy 
) {
    struct timeval start_time;
    struct timeval end_time;
    struct timezone zone;

    gettimeofday(&start_time, &zone);

    long int i;		// Loop counter
    for (i = 0; i < 10000; ++i) {
	switch (copy) {
	    case COPY_NULL:
		// Do nothing
		break;
	    case COPY_ME:
		my_memcpy(big_array, big_array2, sizeof(big_array));
		break;
	    case COPY_SYS:
		memcpy(big_array, big_array2, sizeof(big_array));
		break;
	    default:
		cerr << "Error: Copy flag contains impossible number\n";
		exit (8);
	}
    }

    gettimeofday(&end_time, &zone);
    cout << "Time for ";
    switch (copy) {
	case COPY_NULL:
	    cout << " null copy     ";
	    break;
	case COPY_ME:
	    cout << " my memcpy     ";
	    break;
	case COPY_SYS:
	    cout << " system memcpy ";
	    break;
	default:
	    cerr << "Error: Copy flag contains impossible number\n";
	    exit (8);
    }
    cout << end_time.tv_sec - start_time.tv_sec << '\n';
}

main()
{
    time_copy(COPY_NULL);
    time_copy(COPY_ME);
    time_copy(COPY_SYS);

    return (0);
}



