/********************************************************
 * bad -- read a file replacing bad words with more	*
 *	polite equivalents.				*
 *							*
 * Programming Problem: 26-2				*
 *							*
 * Usage:						*
 *	bad <in_file>					*
 *							*
 * To keep this program rated PG, the bad words aren't	*
 * all that bad.					*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>

#include "words.h"

struct sub {
    char *bad;	// A bad word
    char *good;	// A good word to replace it with
};
static struct sub list[] = {
    {"damn", "darn"},
    {"Damn", "Darn"},
    {"hell", "heck"},
    {"Hell", "Heck"},
    {NULL,    NULL}
};

main(int argc, char *argv[])
{
   char word[LINE_MAX];		// Word we are looking at
   char last_word[LINE_MAX];	// Previous word
   char spaces[LINE_MAX];	// Non-word data
   int i;			// General purpose index

    if (argc != 2) {
	cerr << "Usage is: bad <file>\n";
        exit (8);
    }

    ifstream in_file(argv[1]);	// File we are reading

    if (in_file.bad()) {
        cerr << "Error: Unable to open " << argv[1] << '\n';
	exit (8);
    }

    last_word[0] = '\0';

    words in_word(in_file);	// Word getting class

    // Loop once for each line
    while (1) {
        if (!in_word.next_line()) 
	    break;

	// Loop for each word
	while (1) {
	    in_word.get_word(spaces, word);
	    if (word[0] == '\0') 
	        break;
	    for (i = 0; list[i].bad != NULL; ++i) {
		if (strcmp(list[i].bad, word) == 0) {
		    strcpy(word, list[i].good);
		    break;
		}
	    }
	    cout << spaces << word;
	}
	cout << spaces << '\n';
    }
    return (0);
}

