/********************************************************
 * stest -- test the split function			*
 *							*
 * Programming Problem: 26-5.				*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#include "split.h"

main(int argc, char *argv[])
{
    if (argc != 3) {
	cout << "Usage is: stest <file> <count>\n";
	exit (8);
    }
    ifstream in_file(argv[1]);	// File for reading

    if (in_file.bad()) {
	cerr << "Error: Unable to open " << argv[1] << " for input\n";
	exit (8);
    }

    // Point at which we are splitting
    int point = atoi(argv[2]);
    if (point <= 0) {
	cerr << "Error: Illegal split point\n";
	exit (8);
    }

    while (1) {
	char line[1024];	// Holds very long lines

	in_file.getline(line, sizeof(line));
	if (in_file.eof())
	    break;
  
	char *cur_line = line;	// Current split up line
	while (1) {
	    // Find split point of the line
	    int split_point = split(cur_line, point);

	    if (split_point <= 0) {
		cout << cur_line << '\n';
		break;
	    }

	    // Output current line
	    cur_line[split_point] = '\0';
	    cout << cur_line << '\n';

	    // Move remaining line up
	    cur_line = &cur_line[split_point+1];
	}
    }
    return (0);
}
	   
	    
